/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package matrixproduct;

import javax.naming.directory.InvalidAttributesException;

/**
 *
 * @author bellini
 */
public class MatrixProduct extends Thread {

    private double[][] m1;
    private double[][] m2;
    private double[][] r;
    private int minRow, maxRow;
    private int minCol, maxCol;
    
    public MatrixProduct(double[][] m1, double[][] m2, double[][] r, 
            int minR, int maxR, int minC, int maxC) {
            this.m1=m1;
            this.m2=m2;
            this.r=r;
            if(m2.length!=m1[0].length)
                throw new IllegalArgumentException("m1 and m2 are incompatible");
            if(m1.length != r.length || m2[0].length!=r[0].length)
                throw new IllegalArgumentException("r incompatble with m1*m2");
            minRow=minR;
            maxRow=maxR;
            minCol=minC;
            maxCol=maxC;
            System.out.println("thread "+minR+" "+maxR+" "+minC+" "+maxC);
    }
    
    public void run() {
        for(int i=minRow;i<maxRow; i++)
            for(int j=minCol; j<maxCol; j++) {
                double s=0;
                for(int o=0; o<m2.length; o++)
                    s+=m1[i][o]*m2[o][j];
                r[i][j]=s;
            }
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        double[][] m1 = new double[20][40];
        double[][] m2 = new double[40][10];
        double[][] r = new double[20][10];
        
        initMatrix(m1);
        initMatrix(m2);
        int nt = 5; //numero thread
        int nr = m1.length; //n. righe matrice risultato
        int nc = m2[0].length; //n. colonne matrice risultato
        MatrixProduct[] t = new MatrixProduct[nt];
        for(int i=0; i<nt; i++) {
            if(nr>nc) {
                int nrt=(nr+nt-1)/nt;
                t[i]=new MatrixProduct(m1, m2, r, i*nrt, 
                        Math.min((i+1)*nrt,nr), 0, nc);
            } else {
                int nct=(m2[0].length+nt-1)/nt;
                t[i]=new MatrixProduct(m1,m2,r,0,nr, i*nct,
                    Math.min((i+1)*nct, nc));
            }
            t[i].start();
        }
        try {
            for(int i=0; i<nt; i++)
                t[i].join();
        } catch(InterruptedException e) {            
        }
 
        printMatrix(r);
    }
    
    public static void initMatrix(double[][] m) {
        for(int i=0; i<m.length; i++) 
            for(int j=0; j<m[0].length; j++)
                m[i][j]=Math.random();
    }
    
    public static void printMatrix(double[][] m) {
        for(int i=0; i<m.length; i++) { 
            for(int j=0; j<m[0].length; j++)
                System.out.print(m[i][j]+" ");
            System.out.println();
        }
    }
    
}
