/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package museumrooms;

/**
 *
 * @author bellini
 */
public class MuseumRooms {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws InterruptedException {
        Room[] r=new Room[10];
        for(int i=0; i<r.length; i++)
            r[i]=new Room(i,i%2==0 ? 1 : 2);
        Visitor[] v=new Visitor[10];
        for(int i=0; i<v.length; i++) {
            v[i]=new Visitor(i,2,r);
            v[i].start();
        }
        for(int i=0; i<v.length; i++) {
            v[i].join();
        }
        for(int i=0; i<r.length; i++) {
            System.out.println("stanza "+i+" maxQ: "+r[i].getMaxQueue()+" acc:"+r[i].getAccessed());
        }
    }
    
}

class Room {
    private int id;
    private int count;
    private int capacity;
    private int accessed;
    private int queue;
    private int maxQueue;
    
    public Room(int id, int capacity) {
        this.id=id;
        this.capacity=capacity;
        count=accessed=queue=maxQueue=0;
    }
    
    public synchronized void enter() throws InterruptedException {
        while(count==capacity) {
            queue++;
            if(queue>maxQueue)
                maxQueue=queue;
            wait();
            queue--;
        }
        accessed++;
        count++;
    }
    
    public synchronized void exit() {
        count--;
        notifyAll();
    }
    
    public int getMaxQueue() {
        return maxQueue;
    }
    
    public int getAccessed() {
        return accessed;
    }
}

class Visitor extends Thread {
    private Room[] rooms;
    private int id;
    private int n;
    
    public Visitor(int id, int n, Room[] r) {
        this.id=id;
        this.rooms=r;
        this.n=n;
    }
    
    public void run() {
        try {
        for(int i=0; i<n; i++)
            for(int j=0; j<rooms.length; j++) {
                rooms[j].enter();
                System.out.println("visitor "+id+" enter room "+j);
                Thread.sleep((long)(Math.random()*1000));
                rooms[j].exit();
                System.out.println("visitor "+id+" exit room "+j);
            }
        } catch(InterruptedException e) {
            
        }
    }
}
