/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package producerconsumer;

import java.util.concurrent.Semaphore;

/**
 *
 * @author bellini
 */
public class SharedBufferWithSemaphores implements SharedBuffer {
    
    private Object[] data;
    private Semaphore mutex;
    private Semaphore empty;
    private Semaphore full;
    private int addPos,removePos;
    
    public SharedBufferWithSemaphores(int n) {
        data=new Object[n];
        mutex = new Semaphore(1);
        empty = new Semaphore(n);
        full = new Semaphore(0);
        addPos = removePos = 0;
    }
    
    @Override
    public void add(Object o) throws InterruptedException {
        empty.acquire();
        mutex.acquire();
        data[addPos] = o;
        addPos = (addPos+1)%data.length;
        System.out.println("add n: "+empty.availablePermits());
        mutex.release();
        full.release();
    }
    
    public Object remove() throws InterruptedException {
        full.acquire();
        mutex.acquire();
        Object r = data[removePos];
        removePos = (removePos+1)%data.length;
        System.out.println("remove n: "+empty.availablePermits());
        mutex.release();
        empty.release();
        return r;
    }
}
