/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package producerconsumer;

/**
 *
 * @author bellini
 */
public class SharedBufferWithSynch implements SharedBuffer {
    private Object data[];
    private int addPos, removePos;
    private int count;
    
    public SharedBufferWithSynch(int n) {
        data=new Object[n];
        addPos=0;
        removePos=0;
        count=0;
    }
    
    public synchronized void add(Object o) throws InterruptedException {
        while(count==data.length)
            wait();
        data[addPos]=o;
        addPos=(addPos+1)%data.length;
        count++;
        notifyAll();
    }
    
    public synchronized Object remove() throws InterruptedException {
        while(count==0)
            wait();
        Object r=data[removePos];
        removePos=(removePos+1)%data.length;
        count--;
        notifyAll();
        return r;
    }
}
