/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package readerwriter;

import java.util.concurrent.Semaphore;

/**
 *
 * @author bellini
 */
public class DatabaseAccesWithSemaphore implements DatabaseAccess {
    private Semaphore mutex;
    private Semaphore writer;
    private int nReaders;
    
    public DatabaseAccesWithSemaphore() {
        mutex=new Semaphore(1);
        writer=new Semaphore(1);
        nReaders = 0;
    }
    
    public void startWrite() throws InterruptedException {
        writer.acquire();
    }
    public void endWrite() {
        writer.release();
    }
    
    public void startRead() throws InterruptedException {
        mutex.acquire();
        nReaders++;
        if(nReaders==1)
            writer.acquire();
        mutex.release();
    }
    
    public void endRead() throws InterruptedException {
        mutex.acquire();
        nReaders--;
        if(nReaders==0)
            writer.release();
        mutex.release();
    }
}
