/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package readerwriter;

/**
 *
 * @author bellini
 */
public class DatabaseAccessWithSynch implements DatabaseAccess {

    private int nReaders = 0;
    private int nWriters = 0;
    
    @Override
    public synchronized void startRead() throws InterruptedException {
        while(nWriters>0) 
            wait();
        nReaders++;
        notifyAll();
    }

    @Override
    public synchronized void endRead() throws InterruptedException {
        nReaders--;
        notifyAll();
    }

    @Override
    public synchronized void startWrite() throws InterruptedException {
        while(nReaders>0 || nWriters>0)
            wait();
        nWriters++;
        notifyAll();
    }

    @Override
    public synchronized void endWrite() {
        nWriters--;
        notifyAll();
    }

}
